/*
 * JBoss, Home of Professional Open Source
 * Copyright (c) 2010, JBoss Inc., and individual contributors as indicated
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.test.metadata.jbpapp5040.unit;

import org.jboss.metadata.ejb.spec.EjbJarMetaData;
import org.jboss.test.metadata.ejb.AbstractEJBEverythingTest;

import java.lang.reflect.Field;
import java.nio.charset.Charset;

/**
 * @author <a href="mailto:cdewolf@redhat.com">Carlo de Wolf</a>
 */
public class FileEncodingTestCase extends AbstractEJBEverythingTest
{
   public FileEncodingTestCase(String name)
   {
      super(name);
   }

   private static void flushCharset() throws Exception
   {
      Field field = Charset.class.getDeclaredField("defaultCharset");
      field.setAccessible(true);
      field.set(null, null);
   }

   public void testUTF8() throws Exception
   {
      EjbJarMetaData ejbJar = unmarshal("ejb-jar_utf-8.xml", EjbJarMetaData.class);

      String s = ejbJar.getEnterpriseBean("EncodedBean").getEnvironmentEntryByName("encodedCharacter").getValue();
      assertEquals("é", s);
      System.out.println(s);
   }

   public void testWindows1252() throws Exception
   {
      EjbJarMetaData ejbJar = unmarshal("ejb-jar_windows-1252.xml", EjbJarMetaData.class);

      String s = ejbJar.getEnterpriseBean("EncodedBean").getEnvironmentEntryByName("encodedCharacter").getValue();
      assertEquals("é", s);
      System.out.println(s);
   }
}
